# Noronha Contribution Guidelines

Thank you for your interest in this project!

When contributing to Noronha, it is assumed that you are comfortable with the following technologies:

- Object oriented Python 3
- Docker (engine and Swarm)
- Kubernetes
- Machine Learning
- MongoDB
- DevOps pipelines
- REST API’s
- YAML

It is also recommended that you are familiar with Noronha from a user perspective (i.e.: have read all sections in readthedocs)

### Overview

There are a number of ways in which you can contribute with the Noronha project:

- Help us improve the documentation
- Develop improvements and new features to Noronha
- Testing and quality assurance
- Write test cases for open bug issues
- Write patches for open bug/feature issues, preferably with test cases included
- Blog about different ways you are using Noronha to help other users
- Contribute to discussions in open issues
- Help others in Stack Overflow by using #noronha-dataops hashtag

### Starting a discussion 

Feel free to send an e-mail to our [Google Groups](https://groups.google.com/g/noronha-dataops): [noronha-dataops@googlegroups.com](mailto:noronha-dataops@googlegroups.com).

Or reach out using GitHub [issues](https://github.com/noronha-dataops/noronha/issues).

If you want to contact the original creators instead, use this e-mail: [noronha.mlops@nttdata.com](mailto:noronha.mlops@nttdata.com).

### Contribution Workflow

Please attend to this workflow if you want to make contributions that directly affect Noronha code.

- Submit an issue, assuming one does not already exist.
- Clearly describe the issue/feature:
  - Steps to reproduce if it's a bug. Make sure you fill in the earliest version that you know has the issue.
  - Use cases and current alternatives if it's a feature request.
- Make sure to coordinate effort and ensure that the feature is approved and not being worked on.
- Fork the repository in GiHub.
- Use descriptive commit messages and reference the #issue number on your changes. e.g.: resolved #xxx
- Make sure your work is based on the latest master commit beforing submitting a PR.
- Create pull request.

### Legal aspects

All code contributors are required to sign the Noronha Contribution License Agreement. This is an automatic process thanks to [cla-assistant](https://cla-assistant.io/#Stage).

After you submit a pull request, the CLAassistant bot will request your CLA signature. You can sign in with GitHub in order to agree.
